var PI = 3.1415926535898;
var HALFPI = PI / 2.0;
var easingType = "SinEaseIn";
// For pasting in UMENU :
// SinEaseIn, SinEaseOut, SinEaseInOut, ExponentialEaseIn, ExponentialEaseOut, ExponentialEaseInOut, QuarticEaseIn, QuarticEaseOut, QuarticEaseInOut, CircularEaseIn, CircularEaseOut, CircularEaseInOut, ElasticEaseIn, ElasticEaseOut, ElasticEaseInOut, QuadraticEaseIn, QuadraticEaseOut, QuadraticEaseInOut, CubicEaseIn, CubicEaseOut, CubicEaseInOut, QuinticEaseIn, QuinticEaseOut, QuinticEaseInOut, 
EaseIn, BackEaseOut, BackEaseInOut, BounceEaseIn, BounceEaseOut, BounceEaseInOut

function easing(v)
{
	easingType = v;
}

function msg_float(value)
{
	var result = 0;
	var tempValue = 0;
	
	switch (easingType) {
		case "SinEaseIn":	outlet(0, Math.sin((value - 1) * PI / 2) + 1); break;
		case "SinEaseOut":	outlet(0, Math.sin(value * PI / 2)); break;
		case "SinEaseInOut":outlet(0, 0.5 * (1 - Math.cos(value * PI))); break;
		case "ExponentialEaseIn":	outlet(0, (value == 0 ? value : Math.pow(2, 10 * (value - 1)))); break;
		case "ExponentialEaseOut":	outlet(0, (value == 1 ? value : 1 - Math.pow(2, -10 * value))); break;
		case "ExponentialEaseInOut":
			result = value;
			if(value > 0 && value < 0.5) {
				result = 0.5 * Math.pow(2, 20 * value - 10);
			}
			else if(value < 1 && value > 0.5) {
				result = -0.5 * Math.pow(2, -20 * value + 10) + 1;
			}
			outlet(0, result); 
			break;
		case "QuarticEaseIn":	outlet(0, value * value * value * value); break;
		case "QuarticEaseOut":	
			tempValue = value - 1;
			outlet(0, tempValue * tempValue * tempValue * (1 - value) + 1);
			break;
		case "QuarticEaseInOut":
			result = value;
			if(value < 0.5) {
				result = 8 * value * value * value * value;
			}
			else {
				tempValue = value - 1;
				result = -8 * tempValue * tempValue * tempValue * tempValue + 1;
			}
			outlet (0, result);
			break;
		case "CircularEaseIn":		outlet(0, 1 - Math.sqrt(1 - value * value)); break;
		case "CircularEaseOut":		outlet(0, Math.sqrt((2 - value) * value)); break;
		case "CircularEaseInOut":
			result = 0;
			if(value < 0.5) {
				result = 0.5 * (1 - Math.sqrt(1 - 4 * value * value));
			}
			else {
				result = 0.5 * (Math.sqrt(-((2 * value) - 3) * ((2 * value) - 1)) + 1);
			}
			outlet (0, result);
			break;
		case "ElasticEaseIn":	outlet(0, Math.sin(13 * HALFPI * value) * Math.pow(2, 10 * (value - 1))); break;
		case "ElasticEaseOut":	outlet(0, Math.sin(-13 * HALFPI * (value + 1)) * Math.pow(2, -10 * value) + 1); break;
		case "ElasticEaseInOut":
			result = 0;
			if(value < 0.5) {
				result = 0.5 * Math.sin(13 * HALFPI * 2 * value) * Math.pow(2, 10 * (2 * value - 1));
			}
			else {
				result = 0.5 * (Math.sin(-13 * HALFPI * (2 * value - 1 + 1)) * Math.pow(2, -10 * (2 * value - 1)) + 2);
			}
			outlet(0, result);
			break;
		
		case "QuadraticEaseIn":		outlet(0, value * value); break;
		case "QuadraticEaseOut":	outlet(0, -value * (value - 2)); break;
		case "QuadraticEaseInOut":	
			result = value;
			if(value < 0.5) {
				result = 2 * value * value;
			}
			else {
				post ("aqui");
				result = -2 * value * value + 4 * value - 1;
			}
			outlet(0, result);
			break;
		case "CubicEaseIn":		outlet(0, value * value * value); break;
		case "CubicEaseOut":	
			tempValue = value - 1;
			outlet(0, tempValue * tempValue * tempValue + 1);
			break;
		case "CubicEaseInOut":
			result = value;
			if(value < 0.5) {
				result = 4 * value * value * value;
			}
			else {
				tempValue = 2 * value - 2;
				result = 0.5 * tempValue * tempValue * tempValue + 1;
			}
			outlet(0, result);
			break;
		case "QuinticEaseIn":	outlet(0, value * value * value * value * value); break;
		case "QuinticEaseOut":
			tempValue = value - 1;
			outlet(0, tempValue * tempValue * tempValue * tempValue * tempValue + 1);
			break;
		case "QuinticEaseInOut":
			result = value;
			if(value < 0.5) {
				result = 16 * value * value * value * value * value;
			}
			else {
				tempValue = 2 * value - 2;
				result = 0.5 * tempValue * tempValue * tempValue * tempValue * tempValue + 1;
			}
			outlet(0, result);
			break;
		case "BackEaseIn":		outlet(0, value * value * value - value * Math.sin(value * PI)); break;
		case "BackEaseOut":		
			tempValue = 1 - value;
			outlet(0, tempValue * tempValue * tempValue - tempValue * Math.sin(tempValue * PI));
		break;
		case "BackEaseInOut":
			result = 0;
			if(value < 0.5) {
				tempValue = 2 * value;
				result = 0.5 * (tempValue * tempValue * tempValue - tempValue * Math.sin(tempValue * PI));
			}
			else {
				tempValue = 1 - (2 * value - 1);
				result = (-0.5 * (tempValue * tempValue * tempValue - tempValue * Math.sin(tempValue * PI)) + 1);
			}
			outlet(0, result);
			break;
		case "BounceEaseIn": outlet(0, (1 - BounceEaseOut(1 - value)));	break;
		case "BounceEaseOut":	outlet(0, BounceEaseOut(value)); break;
		case "BounceEaseInOut":
			result = 0;
			if(value < 0.5) {
				result = 0.5 * (1 - BounceEaseOut(1 - (value * 2)));
			}
			else {
				result = 0.5 * BounceEaseOut(value * 2 - 1) + 0.5;
			}
			outlet(0, result);
			break;
	}
}

function BounceEaseOut(value) {
	_BounceEaseOut_ret_1 = 0;
	if(value < 4 / 11) {
		_BounceEaseOut_ret_1 = 121 * value * value / 16;
	}
	else if(value < 8 / 11) {
		_BounceEaseOut_ret_1 = 363 / 40 * value * value - 99 / 10 * value + 17 / 5;
	}
	else if(value < 9 / 10) {
		_BounceEaseOut_ret_1 = 4356 / 361 * value * value - 35442 / 1805 * value + 16061 / 1805;
	}
	else {
		_BounceEaseOut_ret_1 = 54 / 5 * value * value - 513 / 25 * value + 268 / 25;
	}
	return _BounceEaseOut_ret_1;
}